; Diese Script erstellt eine bersicht ber alle Gruppen einer Domne.
; Zur Ausfhrung sind Domnen-Admin-Rechte notwendig
; Es wird auch die Primr-Gruppe eines Benutzers beachtet
;
; Es wird die UDF-Datei "ADFunctions.au3" im Unterordner "Include" erwartet
;
; geschrieben von Michael Schrder, 25.07.2007
 
Opt("MustDeclareVars",1)
#include <include\ADFunctions.au3>

Dim $grparray[1], $userarray[1], $grpindex, $userindex
Dim $memindex, $memarray[1], $file, $name, $mitglieder
Dim $outfile = "ADGruppenuebersicht.htm"

SplashTextOn("","Bitte warten, die Datei" & @CRLF & $outfile & @CRLF & "wird erzeugt." ,"400","100","-1","-1",33,"Times New Roman","18","700")
; Ein Array wird mit allen AD-Gruppen gefllt
_ADGetAllGroups($grparray,$strDNSDomain)
; Ein Array wird mit allen AD-Usern gefllt
_ADGetAllUsers($userarray,$strDNSDomain)
; das User-Array wird um eine Spalte mit der 'PrimaryGroup' erweitert
$userarray = _PGroupAdd($userarray)
$file = FileOpen($outfile,1)
; die HTML-Datei wird erzeugt
FileWriteLine($file,"<HTML>")
FileWriteLine($file,"<BODY>")
FileWriteLine($file,"<TABLE BORDER=" & chr(34) & "1" & chr(34) & ">")
FileClose($file)
For $grpindex = 1 to $grparray[0]
	; ein Array wird mit den Gruppenmitgliedern gefllt
	_ADGetGroupMembers($memarray,$grparray[$grpindex],1)
	; da die User fehlen bei denen diese Gruppe die primre ist,
	; durchsuchen wir das User-Array nach primren Mitgliedschaften
	; und fgen diese User an das Array der Gruppen-Mitglieder an
	For $userindex = 1 to $userarray[0][0]
		If $userarray [$userindex][1] = $grparray[$grpindex] then
			_ArrayAdd($memarray,$userarray[$userindex][0])
			$memarray[0] = UBound($memarray)-1
		EndIf
	Next
	; sortieren neu
	_ArraySort($memarray,0,1)
	; und fllen die Tabellenfelder mit Daten
	$file = FileOpen($outfile,1)
	FileWriteLine($file,"<TR>")
	FileWriteLine($file,"<TD>")
	FileWriteLine($file,_ADDNToSamAccountName($grparray[$grpindex]))
	FileWriteLine($file,"</TD>")
	FileWriteLine($file,"<TD>")
	For $memindex = 1 to $memarray[0]
		$name = _ADDNToSamAccountName($memarray[$memindex])
		if $name = "" then 
			Select
				Case StringInStr($memarray[$memindex],"S-1-1-0") > 0
					$name = _ADGetWellKnownSIDName($memarray[$memindex])
				Case Else
					$name = $memarray[$memindex]
			EndSelect
		EndIf
		$mitglieder &= $name & ", "
	Next
	If $mitglieder <> "" then
		FileWriteLine($file, StringLeft($mitglieder,StringLen($mitglieder)-2))
		$mitglieder = ""
	Else
		FileWriteLine($file, "&nbsp;")
	EndIf
	FileWriteLine($file,"</TD>")
	FileWriteLine($file,"</TR>")
	FileClose($file)
Next
; und schlieen den HTML-Code ab
$file = FileOpen($outfile,1)
FileWriteLine($file,"</TABLE>")
FileWriteLine($file,"</BODY>")
FileWriteLine($file,"</HTML>")
FileClose($file)
SplashOff()

; hier wird mittels zweier ADFunktionen, ein Array mit Usern
; um die primre Gruppe, in einer zweiten Spalte erweitert
Func _PGroupAdd($array)
	Dim $arrayneu[UBound($array)][UBound($array)]
	Dim $index
	$arrayneu[0][0] = $array[0]
	For $index = 1 to UBound($array)-1
		$arrayneu[$index][0] = $array[$index]
		$arrayneu[$index][1] = _ADGetPrimaryGroupDN(_ADGetPrimaryGroupID($array[$index]))
	Next
	Return $arrayneu
EndFunc